/// <reference types="node" />
import { Writable } from 'stream';
export default class FeedMe extends Writable {
    private _buffer;
    private _parser;
    /**
     * Creates an instance of a parser. Parser can be JSON/XML.
     *
     * @param {boolean} buffer If true, feed will be buffered into memory
     *   and can be retrieved using `parser.done()` on the `end` event.
     * @constructor
     */
    constructor(buffer?: boolean);
    _proxyEvents(): void;
    /**
     * @param {Buffer} data
     */
    _write(data: Buffer, encoding: BufferEncoding, callback: (err?: Error | null) => void): void;
    _final(callback: (err?: Error | null) => void): void;
    done(): import("./parser").Feed | undefined;
}
export { Feed, FeedItem, FeedObject } from './parser';
