/// <reference types="node" />
import { Writable } from 'stream';
import { Parser, Feed } from './parser';
/**
 * Parses a JSON feed.
 *
 * @param {boolean} buffer If true, will buffer entire object.
 * @return {CStream}
 */
export default class JSONFeedParser extends Writable implements Parser {
    _buffer: boolean;
    parser: Writable;
    private _currObj;
    private _currKey;
    constructor(buffer: boolean);
    _write(chunk: Buffer, encoding: BufferEncoding, callback: (err?: Error | null) => void): void;
    _final(callback: (err?: Error | null) => void): void;
    done(): Feed | undefined;
}
